/*******************************
 * 
 * index js 依赖mui.js
 * 需要初始化APP运行参数
 * 判断是否首次安装
 * 判断Token是否已过期
 * 
 ------------------------------*/
;(function($){
	var _count=0;//全局消息计数
	$.init({});//初始化mui
	
	var subpages=['pages/message/message.html','pages/rights/right_main2.html','pages/goods/goods_main.html','pages/more/personal.html','pages/relationship/relationship.html'];
	var subpages_id=['message','right_main','shopping','personal','relationship'];

	var subpage_style = {
		top: '45px',
		bottom: '50px'
	};
	var aniShow = {};
	//当前激活选项
	var activeTab = subpages[0];
	var title = Sunjs.getById("title");
	
	$.plusReady(function(){	
		try{
			Sunjs.init();//初始化
			Sunjs.setLocalStorage('appruntime','0');
			
			var _token=Sunjs.token();
			//判断是否有访问令牌
			if(_token===null){
				Sunjs.gettoken1();
			}else{
				//判断是否已过期
				var _timestamp=Date.parse((new Date()).toUTCString())/1000;
				var _expires= _token.timestamp+_token.expires_in;
				if(_timestamp>_expires){
					Sunjs.refreshtoken();
				}
			}
			if(Sunjs.user()!==null){
				Sunjs.getuserinfo();
			}
			start();
			tap();//注册事件
			push.init();//注册推送消息
			
			//扫描事件
			Sunjs.getById('scan').addEventListener('tap',function(){
				var scan=plus.webview.create('scan.html','scan');
				Sunjs.showview(scan);
			});
			
			if(isFirst()){
				//首次安装进入引导页
			 	plus.webview.open('pages/guide.html','guide');
			 	return;
			}
			checkversion();//检查版本
			plus.navigator.closeSplashscreen();
		}catch(ex){
			console.log(ex);
		}
		
	});
	
	//判断是否首次安装
	function isFirst(){
		try{
			var lauchflag=Sunjs.getLocalStorage(localstoragekey.lauchFlag);
			if(lauchflag==undefined){
				Sunjs.setLocalStorage(localstoragekey.version,Sunjs.appVersion);
				return true;
			}
			return false;
		}catch(ex){
			console.log(ex);
		}
		
	}
	
	//首页返回键处理
	//处理逻辑：1秒内，连续两次按返回键，则退出应用；
	var first = null;
	$.back = function() {
		try{
			//首次按键，提示‘再按一次退出应用’
			if (!first) {
				first = new Date().getTime();
				mui.toast('再按一次退出应用');
				setTimeout(function() {
					first = null;
				}, 1000);
			} else {
				if (new Date().getTime() - first < 1000) {
					//_im.close();
					plus.runtime.quit();
				}
			}
		}catch(ex){
			console.log(ex);
		}
	};
	
	function start(){
		try{
			var self = plus.webview.currentWebview();
			for (var i = 0; i < 5; i++) {
				var temp = {};
				var sub = plus.webview.create(subpages[i], subpages_id[i], subpage_style);
				if (i > 0) {
					sub.hide();
				}else{
					temp[subpages_id[i]] = "true";
					$.extend(aniShow,temp);
				}
				//sub.hide();
				self.append(sub);
			}
			//判断是否已登录
			var _user=Sunjs.user();
			if(_user){
				//已登录初始化im
				var __id='U'+_user.id;
				_im.init(__id,Sunjs.hashcode(__id));
			}
		}catch(ex){
			console.log(ex);
		}	
	}
	//注册tab事件
	function tap(){
		try{
			//选项卡点击事件
			$('.sw-navs').on('tap', 'a', function(e) {
				mui.isLongTapAtived=true;
				var targetTab = this.getAttribute('href');
				if (targetTab == activeTab) {
					return;
				}
				
				var _user=Sunjs.user()
				if(loginUrl.indexOf(targetTab)>=0 && (_user===null || _user===undefined)){
					Sunjs.openview('pages/more/login_pwd.html','login');
					return;
				}
				//更改当前活跃的选项卡
				$('.sw-navsCurs')[0].classList.remove('sw-navsCurs');
				this.classList.add('sw-navsCurs');
				
				//更换标题
				title.innerHTML = this.innerHTML;
				if(this.innerHTML.indexOf('消息')>=0){
					title.innerHTML='消息';
				}
				
				//显示目标选项卡
				//若为iOS平台或非首次显示，则直接显示
				if(mui.os.ios||aniShow[targetTab]){
					Sunjs.showview_id(targetTab);
				}else{
					//否则，使用fade-in动画，且保存变量
					var temp = {};
					temp[targetTab] = "true";
					mui.extend(aniShow,temp);
					Sunjs.showview_id(targetTab);
				}
				//隐藏当前;
				plus.webview.hide(activeTab);
				//更改当前活跃的选项卡
				activeTab = targetTab;
			});
		}catch(ex){
			console.log(ex);
		}
		
	}
	//自定义事件 关闭起始页
	document.addEventListener(eventkey.closesplash_event,function(event){
		plus.navigator.closeSplashscreen();
		plus.navigator.setFullscreen(false);
	});
	//自定义事件 初始化窗体
	document.addEventListener(eventkey.initwindow_event,function(event){
		/*var _child= plus.webview.currentWebview().children();
		if(_child!=null && _child.length>0){
			for(var i in _child){
				_child[i].close();
			}
		}
		Sunjs.gettoken(function(){ 
			start();
			tap();
		});*/
		//plus.webview.currentWebview().reload();
		//console.log('窗体初始化');
	});
	//自定义事件 登录后初始化IM
	document.addEventListener(eventkey.iminit_event,function(event){
		var __id='U'+Sunjs.user().id;
		console.log('登录后初始化：'+__id);
		_im.init(__id,Sunjs.hashcode(__id));
	});
	//页面更新事件
	document.addEventListener(eventkey.refresh_event,function(event){
		try{
			var _obj=event.detail;
			if(_obj.type=='login'){
				//登录刷新
				var __id='U'+Sunjs.user().id;
				_im.init(__id,Sunjs.hashcode(__id));
				Sunjs.getById('msg').innerText='消息';
			}else if(_obj.type=='logout'){
				//退出刷新
				_im.close();
				Sunjs.getById('msg').innerText='消息';
			}
		}catch(ex){
			console.log(ex);
		}
		
	});
	
	//是否增量升级
	function checkversion(){
		try{
			plus.runtime.getProperty( plus.runtime.appid, function ( wgtinfo ) {
				var _v=wgtinfo.version;
				Sunjs.ajaxGet(url.version+'?v='+config.version_type,null,function(result){
					if(result.success){
						if(_v===result.data.v){
							return;
						}
						//判断是否为大版本升级
						var _tmp=_v.split('.');
						var _tmp2=result.data.v.split('.');
						if(_tmp[0]!==_tmp2[0]){
							bigupdate(result.data);
							return;
						}
						addupdate(_v,result.data.v);
					}
				});
			});
		}catch(ex){
			console.log(ex);
		}
	}
	function bigupdate(data){
		plus.nativeUI.alert('日上会员已升级，立即更新',function(){
			if(plus.os.name==='Android'){
				plus.runtime.install(data.android_url);
			}else if(plus.os.name==='iOS'){
				plus.runtime.openURL(data.ios_url);
			}
		},'','立即更新');
	}
	function addupdate(oldV,newV){
	    var dtask = plus.downloader.createDownload(url.version_update+'?v='+oldV+'&type='+config.version_type, {}, function(d,status){
	        if(status === 200){
	            plus.runtime.install(d.filename,{},function(){
	            	plus.nativeUI.alert("日上会员已更新将重新启动",function(){
                    	plus.runtime.restart();
	              	});
	            },function(e){
	            	plus.nativeUI.toast(e.message);
	            });
	        } else {
	        	plus.nativeUI.toast('获取服务失败,请退出重试');
	        }
	    });
	    dtask.start();
	}
	//运行环境从前台切换到后台事件
	document.addEventListener('pause',function(){
		Sunjs.setLocalStorage('appruntime','1');
	});
	//运行环境从后台切换到前台事件
	document.addEventListener('resume',function(){
		Sunjs.setLocalStorage('appruntime','0');
		//如果为苹果则重新登录IM
		if(mui.os.ios){
			try{
				var _user=Sunjs.user();
				if(_user===null || _user===''){
					return;
				}
				var __id='U'+_user.id;
				_im.init(__id,Sunjs.hashcode(__id));
			}catch(ex){
				console.log(ex);
			}
		}
	});
	//检测网络
	document.addEventListener('netchange',function(){
		var nt = plus.networkinfo.getCurrentType();
		if (nt === plus.networkinfo.CONNECTION_NONE){
			plus.nativeUI.toast('网络异常，请检查网络设置！');	
		}else if(nt!==plus.networkinfo.CONNECTION_NONE){
			for(var i in subpages_id){
				var _view= plus.webview.getWebviewById(subpages_id[i]);
				if(_view!=null){
					_view.reload(true);	
				}
			}
		}
	},false);
})(mui);
