function loadimg(obj) {
    if (obj.getAttribute('data-loaded')) {
        return;
    }
    var image_url = obj.getAttribute('data-lazyload');
    if (!image_url) {
        return;
    }
    var image_md5 = md5(image_url);
    var pre = image_url.split('.').pop();
    var local_image_url = '_downloads/image/' + image_md5 + '.' + pre; // 缓存本地图片url
    var absolute_image_path = plus.io.convertLocalFileSystemURL(local_image_url); // 平台绝对路径

    plus.io.resolveLocalFileSystemURL(absolute_image_path, function(entry) {
        obj.setAttribute('src', absolute_image_path);
        obj.setAttribute('data-loaded', true);
    }, function(error) {
        function download_img() {
            var download_task = plus.downloader.createDownload(image_url, {
                filename: local_image_url // filename:下载任务在本地保存的文件路径
            }, function(download, status) {
                if (status != 200) {
                    // 下载失败,删除本地临时文件
                    if (local_image_url != null) {
                        plus.io.resolveLocalFileSystemURL(local_image_url, function(entry) {
                            entry.remove(function(entry) {
                                // 重新下载图片
                                download_img();
                            }, function(e) {
                                debug && console.log("临时文件删除失败" + local_image_url);
                            });
                        });
                    }
                } else {
                    // 把下载成功的图片显示
                    // 将本地URL路径转换成平台绝对路径
                    obj.setAttribute('src', plus.io.convertLocalFileSystemURL(local_image_url));
                    obj.setAttribute('data-loaded', true);
                }
            });
            download_task.start();
        }
        download_img();
    });
}