/************************************
 * 
 * message_chat
 * 
 ************************************/
;(function($, doc) {
	var MIN_SOUND_TIME = 800;
	var _index=0;
	$.init();
	Sunjs.init();
	$.plusReady(function() {
		
		template.config('escape', false);
		plus.webview.currentWebview().setStyle({
			softinputMode: "adjustResize"
		});
		var record = [];
		var __chat_id=Sunjs.getLocalStorage('chatid');//与谁聊天-Id
		var __chat_name=Sunjs.getLocalStorage('chatname');//与谁聊天-昵称
		var __chat_type=Sunjs.getLocalStorage('chattype');//聊天类型 单聊、群聊
		Sunjs.getById('title').innerHTML=__chat_name;
		var __value=plus.storage.getItem(localstoragekey.chathistory+'_'+Sunjs.user().id+'_'+__chat_id);//获取历史消息
		if(__value!=null){
			record=JSON.parse(__value);
		}
		var ui = {
			body: doc.querySelector('body'),
			footer: doc.querySelector('footer'),
			footerRight: doc.querySelector('.footer-right'),
			footerLeft: doc.querySelector('.footer-left'),
			btnMsgType: doc.querySelector('#msg-type'),
			boxMsgText: doc.querySelector('#msg-text'),
			boxMsgSound: doc.querySelector('#msg-sound'),
			btnMsgImage: doc.querySelector('#msg-image'),
			areaMsgList: doc.querySelector('#msg-list'),
			boxSoundAlert: doc.querySelector('#sound-alert'),
			h: doc.querySelector('#h'),
			content: doc.querySelector('.mui-content')
		};
		ui.h.style.width = ui.boxMsgText.offsetWidth + 'px';
		//alert(ui.boxMsgText.offsetWidth );
		var footerPadding = ui.footer.offsetHeight - ui.boxMsgText.offsetHeight;
		var msgItemTap = function(msgItem, event) {
			var msgType = msgItem.getAttribute('msg-type');
			var msgContent = msgItem.getAttribute('msg-content')
			if (msgType == 'audio') {
    			var pre = msgContent.split('.').pop();
				var local_audio_url = '_downloads/audio/' + msgContent; // 缓存本地图片url
    			//var absolute_audio_path = plus.io.convertLocalFileSystemURL(local_audio_url); // 平台绝对路径
    			//console.log(absolute_audio_path);
    			plus.io.resolveLocalFileSystemURL(local_audio_url,function(entry){
				 	_play(local_audio_url);
    			},function(error) {
    				function download_audio() {
    					console.log(_sunriseavatar+msgContent);
			            var download_task = plus.downloader.createDownload(_sunriseavatar+msgContent, {
			                filename: local_audio_url // filename:下载任务在本地保存的文件路径
			            }, function(download, status) {
			                if (status != 200) {
			                    // 下载失败,删除本地临时文件
			                    if (local_audio_url != null) {
			                        plus.io.resolveLocalFileSystemURL(local_audio_url, function(entry) {
			                            entry.remove(function(entry) {
			                                // 重新下载图片
			                                download_audio();
			                            }, function(e) {
			                                console.log("临时文件删除失败" + local_audio_url);
			                            });
			                        });
			                    }
			                    console.log('下载失败：'+local_audio_url);
			                } else {
			                	console.log('下载成功：'+local_audio_url);
			                    // 把下载成功播放音频
			                    //_play(plus.io.convertLocalFileSystemURL(local_audio_url));
			                    _play(local_audio_url);
			                }
			            });
			            download_task.start();
			        }
			        download_audio();
    			});
			}
			
			function _play(path){
				try{
					console.log(local_audio_url);
					var player = plus.audio.createPlayer(path);
					var playState = msgItem.querySelector('.play-state');
					playState.innerText = '正在播放...';
					player.play(function() {
						playState.innerText = '点击播放';
					}, function(e) {
						playState.innerText = '点击播放';
					});
				}catch(ex){
					console.log(ex);	
				}
			}
		};
		var imageViewer = new $.ImageViewer('.image-show', {
			dbl: false
		});
		//绑定数据:
		var bindMsgList = function() {
			var _array=array_pager();
			//获取好友信息
			var _values=plus.storage.getItem('friends'+Sunjs.user().id);
	    	if(_values===null){
	    		return;
	    	}
	    	var _friends=JSON.parse(_values);
	    	for(var i=0;i<_array.length;i++){
				for(var j=0;j<_friends.length;j++){
					if('u'+_friends[j].id===_array[i].from){
						_array[i].nickname=_friends[j].nickname;
						_array[i].avatar=_friends[j].avatar;
					}
				}
			}
			ui.areaMsgList.innerHTML = template('msg-template', {
				"record": _array
			});
			mui('.mui-icon-person').each(function(){
				loadimg(this);
			});
			mui('.msg-user-img').each(function(){
				loadimg(this);
			});
			var msgItems = ui.areaMsgList.querySelectorAll('.msg-item');
			[].forEach.call(msgItems, function(item, index) {
				item.addEventListener('tap', function(event) {
					msgItemTap(item, event);
				}, false);
			});
			imageViewer.findAllImage();
			ui.areaMsgList.scrollTop = ui.areaMsgList.scrollHeight + ui.areaMsgList.offsetHeight;
		};
		bindMsgList();
		window.addEventListener('resize', function() {
			ui.areaMsgList.scrollTop = ui.areaMsgList.scrollHeight + ui.areaMsgList.offsetHeight;
		}, false);
		//发送消息
		var send = function(msg) {
			try{
				record.push({
					self:1,
					msgtype:msg.msgtype,
					msg:msg.msg,
					from:Sunjs.user().id
				});
				create_element({
					self:1,
					msgtype:msg.msgtype,
					msg:msg.msg,
					from:Sunjs.user().id
				});
				//获得主页面的webview
				var main = plus.webview.getLaunchWebview();
				var _to=Sunjs.getLocalStorage('chatid');
				var _chattype=Sunjs.getLocalStorage('chattype');
				//触发主页面的sendmsg事件
				mui.fire(main,eventkey.sendmsg_event,{
				    to : _to,//发送给谁
				    msg :msg.msg,//消息内容
				    type:_chattype,// 单聊 群聊
				    msgtype:msg.msgtype //消息类型 文本 图片 音频
				});
			}catch(ex){
				console.log(ex);
			}
			
		};

		function msgTextFocus() {
				ui.boxMsgText.focus();
				setTimeout(function() {
					ui.boxMsgText.focus();
				}, 150);
			}
		//解决长按“发送”按钮，导致键盘关闭的问题；
		ui.footerRight.addEventListener('touchstart', function(event) {
			if (ui.btnMsgType.classList.contains('mui-icon-paperplane')) {
				msgTextFocus();
				event.preventDefault();
			}
		});
		//解决长按“发送”按钮，导致键盘关闭的问题；
		ui.footerRight.addEventListener('touchmove', function(event) {
			if (ui.btnMsgType.classList.contains('mui-icon-paperplane')) {
				msgTextFocus();
				event.preventDefault();
			}
		});
		ui.footerRight.addEventListener('release', function(event) {
			if (ui.btnMsgType.classList.contains('mui-icon-paperplane')) {
				//showKeyboard();
				ui.boxMsgText.focus();
				setTimeout(function() {
					ui.boxMsgText.focus();
				}, 150);
				send({
					self: '1',
					msgtype: 'text',
					msg: ui.boxMsgText.value.replace(new RegExp('\n', 'gm'), '<br/>')
				});
				ui.boxMsgText.value = '';
				$.trigger(ui.boxMsgText, 'input', null);
			} else if (ui.btnMsgType.classList.contains('mui-icon-mic')) {
				ui.btnMsgType.classList.add('mui-icon-compose');
				ui.btnMsgType.classList.remove('mui-icon-mic');
				ui.boxMsgText.style.display = 'none';
				ui.boxMsgSound.style.display = 'block';
				ui.boxMsgText.blur();
				document.body.focus();
			} else if (ui.btnMsgType.classList.contains('mui-icon-compose')) {
				ui.btnMsgType.classList.add('mui-icon-mic');
				ui.btnMsgType.classList.remove('mui-icon-compose');
				ui.boxMsgSound.style.display = 'none';
				ui.boxMsgText.style.display = 'block';
				//--
				//showKeyboard();
				ui.boxMsgText.focus();
				setTimeout(function() {
					ui.boxMsgText.focus();
				}, 150);
			}
		}, false);
		//发送照片
		ui.footerLeft.addEventListener('tap', function(event) {
			var btnArray = [{
				title: "拍照"
			}, {
				title: "从相册选择"
			}];
			plus.nativeUI.actionSheet({
				title: "选择照片",
				cancel: "取消",
				buttons: btnArray
			}, function(e) {
				try{
					var index = e.index;
					var _path='';
					switch (index) {
						case 0:
							return
						case 1:
							var cmr = plus.camera.getCamera();
							cmr.captureImage(function(path) {
								console.log(path);
								//sendimg(plus.io.convertLocalFileSystemURL(path));
								sendimg(path);
							}, function(err) {
								plus.nativeUI.toast(err);
							});
							break;
						case 2:
							plus.gallery.pick(function(path) {
								sendimg(path);
							}, function(err) {}, null);
							break;
					}
				}catch(ex){
					console.log('异常');
				}
			});
		}, false); 
		var setSoundAlertVisable=function(show){
			if(show){
				ui.boxSoundAlert.style.display = 'block';
				ui.boxSoundAlert.style.opacity = 1;
			}else{
				ui.boxSoundAlert.style.opacity = 0;
				//fadeOut 完成再真正隐藏
				setTimeout(function(){
					ui.boxSoundAlert.style.display = 'none';
				},200);
			}
		};
		var recordCancel = false;
		var recorder = null;
		var audio_tips = document.getElementById("audio_tips");
		var startTimestamp = null;
		var stopTimestamp = null;
		var stopTimer = null;
		ui.boxMsgSound.addEventListener('hold', function(event) {
			recordCancel = false;
			if(stopTimer)clearTimeout(stopTimer);
			audio_tips.innerHTML = "手指上划，取消发送";
			ui.boxSoundAlert.classList.remove('rprogress-sigh');
			setSoundAlertVisable(true);
			recorder = plus.audio.getRecorder();
			if (recorder == null) {
				plus.nativeUI.toast("不能获取录音对象");
				return;
			}
			startTimestamp = (new Date()).getTime();
			recorder.record({
				filename: "_doc/audio/"
			}, function(path) {
				if (recordCancel) return;
				//上传录音文件
				sendAudio(path);
			}, function(e) {
				plus.nativeUI.toast("录音时出现异常: " + e.message);
			});
		}, false);
		ui.body.addEventListener('drag', function(event) {
			//console.log('drag');
			if (Math.abs(event.detail.deltaY) > 50) {
				if (!recordCancel) {
					recordCancel = true;
					if (!audio_tips.classList.contains("cancel")) {
						audio_tips.classList.add("cancel");
					}
					audio_tips.innerHTML = "松开手指，取消发送";
				}
			} else {
				if (recordCancel) {
					recordCancel = false;
					if (audio_tips.classList.contains("cancel")) {
						audio_tips.classList.remove("cancel");
					}
					audio_tips.innerHTML = "手指上划，取消发送";
				}
			}
		}, false);
		ui.boxMsgSound.addEventListener('release', function(event) {
			//console.log('release');
			if (audio_tips.classList.contains("cancel")) {
				audio_tips.classList.remove("cancel");
				audio_tips.innerHTML = "手指上划，取消发送";
			}
			//
			stopTimestamp = (new Date()).getTime();
			if (stopTimestamp - startTimestamp < MIN_SOUND_TIME) {
				audio_tips.innerHTML = "录音时间太短";
				ui.boxSoundAlert.classList.add('rprogress-sigh');
				recordCancel = true;
				stopTimer=setTimeout(function(){
					setSoundAlertVisable(false);
				},800);
			}else{
				setSoundAlertVisable(false);
			}
			recorder.stop();
		}, false);
		ui.boxMsgSound.addEventListener("touchstart", function(e) {
			//console.log("start....");
			e.preventDefault();
		});
		ui.boxMsgText.addEventListener('input', function(event) {
			ui.btnMsgType.classList[ui.boxMsgText.value == '' ? 'remove' : 'add']('mui-icon-paperplane');
			ui.btnMsgType.setAttribute("for", ui.boxMsgText.value == '' ? '' : 'msg-text');
			ui.h.innerText = ui.boxMsgText.value.replace(new RegExp('\n', 'gm'), '\n-') || '-';
			ui.footer.style.height = (ui.h.offsetHeight + footerPadding) + 'px';
			ui.content.style.paddingBottom = ui.footer.style.height;
		});
		var focus = false;
		ui.boxMsgText.addEventListener('tap', function(event) {
			ui.boxMsgText.focus();
			setTimeout(function() {
				ui.boxMsgText.focus();
			}, 0);
			focus = true;
			setTimeout(function () {
				focus = false;
			},1000);
			event.detail.gesture.preventDefault();
		}, false);
		//点击消息列表，关闭键盘
		ui.areaMsgList.addEventListener('tap',function (event) {
			if(!focus){
				ui.boxMsgText.blur();
			}
		})
		
		doc.addEventListener(eventkey.chat_event,function(event){
			record.push(event.detail);
			//bindMsgList();
			create_other_element(event.detail);
		});
		//发送图片
		function sendimg(path){
			console.log(path);
			plus.nativeUI.showWaiting();
			//1上传到服务器 2显示图片
			var __array=path.split('.');
			var __sp=__array[__array.length-1];
			console.log(__sp);
			var _to= Sunjs.getLocalStorage('chatid');
			var _date=new Date();
			var __filename='chat_img_'+_to+'_'+_date.getFullYear()+''+(_date.getMonth()+1)+_date.getDate()+_date.getHours()+_date.getMinutes()+_date.getSeconds()+_date.getMilliseconds()+'.'+__sp;
			console.log(__filename);
			//压缩图片
			plus.zip.compressImage( {
				src:path,
				dst:__filename,
				quality:80,
				overwrite:true
			}, function(event){
				console.log('压缩成功');
				//上传到服务器
				var task= plus.uploader.createUpload(_sunriseupload, {}, function(t, status){
					// 上传完成
					if ( status == 200 ) {
						plus.nativeUI.closeWaiting();
						//上传成功发送消息
						send({
							msg:__filename,
							msgtype:imkey.picture_msg
						});
					} else {
						plus.nativeUI.closeWaiting();
						plus.nativeUI.toast('上传失败：'+status);
					}
				});
				task.addFile(event.target,{name:__filename});
				task.start();
				console.log(event.target);
				
			}, function(error){
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast(error.message);
				console.log(error.code+'  ' +error.message);
			});
		}
		//发送音频
		function sendAudio(path){
			recorder.stop();
			plus.nativeUI.showWaiting();
			//var _path=plus.io.convertLocalFileSystemURL(path);
			var _path=path;
			console.log(_path);
			
			var __array=path.split('.');
			var __sp=__array[__array.length-1];
			console.log(__sp);
			var _to= Sunjs.getLocalStorage('chatid');
			var _date=new Date();
			var __filename='chat_audio_'+_to+'_'+_date.getFullYear()+''+(_date.getMonth()+1)+_date.getDate()+_date.getHours()+_date.getMinutes()+_date.getSeconds()+_date.getMilliseconds()+'.'+__sp;
			console.log(__filename);
			//上传到服务器
			var task= plus.uploader.createUpload(_sunriseupload, {}, function(t, status){
				// 上传完成
				if ( status == 200 ) {
					plus.nativeUI.closeWaiting();
					//上传成功发送消息
					send({
						msg:__filename,
						msgtype:imkey.audio_msg
					});
				} else {
					plus.nativeUI.closeWaiting();
					plus.nativeUI.toast('上传失败：'+status);
				}
			});
			task.addFile(_path,{name:__filename});
			task.start();
			console.log(_path);
		}
		//创建element
		function create_element(obj){
			var _element=document.createElement('div');
			_element.setAttribute('class','msg-item msg-item-self');
			_element.setAttribute('msg-type',obj.msgtype);
			_element.setAttribute('msg-content',obj.msg);
			_element.innerHTML=template('msg-my-template', {"item": obj});
			
			loadimg(_element.getElementsByTagName('img')[0]);
			Sunjs.getById('msg-list').appendChild(_element);
			ui.areaMsgList.scrollTop = ui.areaMsgList.scrollHeight + ui.areaMsgList.offsetHeight;
			
			
			_element.addEventListener('tap', function(event) {
				msgItemTap(_element, event);
			}, false);
			imageViewer.findAllImage();
		}
		//创建其他element
		function create_other_element(obj){
			//获取好友信息
			var _values=plus.storage.getItem('friends'+Sunjs.user().id);
	    	if(_values===null){
	    		return;
	    	}
	    	var _friends=JSON.parse(_values);
	    	for(var j=0;j<_friends.length;j++){
				if('u'+_friends[j].id===obj.from){
					obj.nickname=_friends[j].nickname;
					obj.avatar=_friends[j].avatar;
					break;
				}
			}
			var _element=document.createElement('div');
			_element.setAttribute('class','msg-item');
			_element.setAttribute('msg-type',obj.msgtype);
			_element.setAttribute('msg-content',obj.msg);
			_element.innerHTML=template('msg-other-template', {"item": obj});
			
			loadimg(_element.getElementsByTagName('img')[0]);
			Sunjs.getById('msg-list').appendChild(_element);
			ui.areaMsgList.scrollTop = ui.areaMsgList.scrollHeight + ui.areaMsgList.offsetHeight;
			
			_element.addEventListener('tap', function(event) {
				msgItemTap(_element, event);
			}, false);
			imageViewer.findAllImage();
		}
		//数组分页
		function array_pager(pageindex){
			return record;
			if(record===null || record.length===0)
				return record;
			var _pagesize=12;
			var _array=[];
			pageindex=(pageindex<=0 || pageindex==undefined)?1:pageindex;
			if(pageindex===1 || pageindex===undefined){
				if(record.length<=_pagesize){
					return record;	
				}
				var i=record.length-1;
				console.log(record.length-_pagesize);
				for(i;i>(record.length-_pagesize);i--){
					console.log(i);
					_array.push(record[i]);
				}
				console.log(JSON.stringify(_array));
				return _array.reverse();
			}
			if(_pagesize*pageindex>record.length){
				var i=record.length-(pageindex-1)*_pagesize-1;
				for(i;i<0;i--){
					_array.push(record[i]);
				}
				return _array.reverse();
			}else{
				var i=record.length-(pageindex-1)*_pagesize-1;
				for(i;i<(record.length-pageindex*_pagesize);i--){
					_array.push(record[i]);	
				}
				return _array.reverse();
			}
		}
		
		mui('#msg-list').on('tap','.pro-detail',function(){
			var _id=this.getAttribute('data-id');
			if(_id===null || _id===''){
				return;
			}
			Sunjs.setLocalStorage(localstoragekey.product_id,_id);
			Sunjs.openview('../goods/goods_detail.html', 'goods_detail');
		});
	});
	template.helper('av_nick',function(uid){
		return Sunjs.getIM(uid);
	});
	template.helper('myavatar',function(){
		return Sunjs.user().avatar;
	});
	/*
	mui('#msg-list').on('tap','.msg-item',function(){
		alert('tttt');
	});*/
}(mui, document));